%%  AMAE 2005
%%  Code for HW5     
%%
%%   NOTE 1: This file assumes that the covariance matrix of exogenous shocks (Sigma)  
%%    is an identity  matrix of size 2 X 2. If this is not what you need change Sigma below.
%%   NOTE 2: The matrix NN is assumed to be a diagonal matrix.
%%   If this is not what you need correct NN below. 

%%  SETTING  PARAMETERS:

	beta	=0.989;   %
	delta	=0.019;   %
	alpa	=0.4;   %
	sigma_z	=0.007;   %
	alpa	=0.4;   %
	delta	=0.019;   %
	rho	=0.95;   %
	b	=0.005;   %
	eta	=1;   %
	sigma_u	=0.0089;   %
	THETA	=1.0125;   %
	phi	=2;   %
	gamma_u	=0;   %
	gamma_z	=0;   %
	n_bar	=0.31;   %
	theta_bar	=THETA-1;   %
	pie_bar	=theta_bar;   %
	R_bar	=1/beta;   %
	yk_bar	=(R_bar-1+delta)/alpa;   %
	kn_bar	=(yk_bar)^(1/(alpa-1));   %
	i_bar	=(1+pie_bar-beta)/beta;   %
	z_bar	=1;   %
	k_bar	=n_bar*(yk_bar)^(1/(alpa-1));   %
	x_bar	=delta*k_bar;   %
	y_bar	=k_bar^alpa*n_bar^(1-alpa);   %
	c_bar	=y_bar-x_bar;   %
	m_bar	=b*c_bar*(1+i_bar)/i_bar;   %
	lamda_bar	=c_bar^(-phi)*m_bar^(b*(1-phi));   %
	A	=1+eta*n_bar/(1-n_bar);   %
	d1	=(1+alpa*y_bar*(1-alpa)/(R_bar*k_bar*(A-1+alpa)));   %
	d2	=alpa*y_bar*(A*alpa-A+1-alpa)/(R_bar*k_bar*(A-1+alpa));   %
	d3	=alpa*y_bar*(1-alpa)/(R_bar*k_bar*(A-1+alpa));   %
	d4	=alpa*y_bar*rho*A/(R_bar*k_bar*(A-1+alpa));   %
	d5	=i_bar/(1+i_bar);   %

%%  DECLARING THE MATRICES: 

VARNAMES = [  'capital                       ',	%1  X1
	 'money balance                 ',	%2  X2
	 'output                        ',	%3  Y1
	 'labor                         ',	%4  Y2
	 'real interest rate            ',	%5  Y3
	 'nominal interest rate         ',	%6  Y4
	 'inflation                     ',	%7  Y5
	 'consumption                   ',	%8  Y6
	 'shadow price                  ',	%9  Y7
	 'investment                    ',	%10  Y8
	 'technology shock              ',	%11  Z1
	 'monetary shock                ']	%12  Z2


%%  EQUATIONS: 

%% NON-EXPECTATIONAL EQUATIONS: 

% (1)  0  =  -lamda(t)-phi*c(t)+b*(1-phi)*m(t)
% (2)  0  =  -A*n(t)+lamda(t)+y(t)
% (3)  0  =  alpa*k(t-1)+(1-alpa)*n(t)+z(t)-y(t)
% (4)  0  =  -y_bar*y(t)+c_bar*c(t)+k_bar*k(t)-k_bar*(1-delta)*k(t-1)
% (5)  0  =  -d1*R(t)+d2*k(t)+d3*lamda(t)+d4*z(t)
% (7)  0  =  d5*i(t)+m(t)-b*c(t)
% (9)  0  =  -m(t)+m(t-1)-pie(t)+u(t)
% (10)  0  =  -x_bar*x(t)+k_bar*k(t)-(1-delta)*k_bar*k(t-1)

%% EXPECTATIONAL EQUATIONS: 

% (6)  0  =  E_t{  -lamda(t)+R(t)+lamda(t+1)  }
% (8)  0  =  E_t{  -i(t)+R(t)+pie(t+1)  }

%% EXOGENOUS EQUATIONS: 

% (11)   z(t+1)  =  rho*z(t)+ iidShock(t+1) ; with E_t { iidShock(t+1) }=0
% (12)   u(t+1)  =  gamma_u*u(t)+gamma_z*z(t)+ iidShock(t+1) ; with E_t { iidShock(t+1) }=0

%% FIND MATRICES FOR FORMAT: 

% 0  =  AA*X(t)+BB*X(t-1)+CC*Y(t)+DD*Z(t) 

%   AA  8x2
%   BB  8x2
%   CC  8x8
%   DD  8x2

% 0  =  E_t{ FF*X(t+1)+GG*X(t)+HH*X(t-1)+JJ*Y(t+1)+KK*Y(t)+LL*Z(t+1)+MM*Z(t) } 

%   FF  2x2
%   GG  2x2
%   HH  2x2
%   JJ  2x8
%   KK  2x8
%   LL  2x2
%   MM  2x2

% Z(t+1)  =  NN*Z(t)+epsilon(t+1),  with E_t{epsilon(t+1)}=0 

%   NN  2x2

   AA=zeros(8,2); 
   AA(1,2)=b*(1-phi) ; 
   AA(4,1)=k_bar ; 
   AA(5,1)=d2 ; 
   AA(6,2)=1 ; 
   AA(7,2)=-1 ; 
   AA(8,1)=k_bar ;

display (AA); 

   BB=zeros(8,2); 
   BB(3,1)=alpa ; 
   BB(4,1)=-k_bar*(1-delta) ; 
   BB(7,2)=1 ; 
   BB(8,1)=-(1-delta)*k_bar ;

display (BB);

   CC=zeros(8,8); 
   CC(1,7)=-1 ; 
   CC(1,6)=-phi ; 
   CC(2,2)=-A ; 
   CC(2,7)=1 ; 
   CC(2,1)=1 ; 
   CC(3,2)=(1-alpa) ; 
   CC(3,1)=-1 ; 
   CC(4,1)=-y_bar ; 
   CC(4,6)=c_bar ; 
   CC(5,3)=-d1 ; 
   CC(5,7)=d3 ; 
   CC(6,4)=d5 ; 
   CC(6,6)=-b ; 
   CC(7,5)=-1 ; 
   CC(8,8)=-x_bar ;

display (CC);
disp('rank of CC');
rank(CC)

   DD=zeros(8,2); 
   DD(3,1)=1 ; 
   DD(5,1)=d4 ; 
   DD(7,2)=1 ;

display (DD);

   FF=zeros(2,2);

display (FF);

   GG=zeros(2,2);

display (GG);

   HH=zeros(2,2);

display (HH);

   JJ=zeros(2,8); 
   JJ(1,7)=1 ; 
   JJ(2,5)=1 ;

display (JJ);

   KK=zeros(2,8); 
   KK(1,7)=-1 ; 
   KK(1,3)=1 ; 
   KK(2,4)=-1 ; 
   KK(2,3)=1 ;

display (KK);

   LL=zeros(2,2);

display (LL);

   MM=zeros(2,2);

display (MM);

   NN=zeros(2,2); 
   NN(1,1)=rho ; 
   NN(2,2)=gamma_u ; 
   NN(2,1)=gamma_z ;

display (NN);

   Sigma=eye(2,2);  %% assumes Standard Deviation =1 for all shocks & no correlation among shocks
   Sigma(1,1)=sigma_z;
   Sigma(2,2)=sigma_u
    
% SETTING OPTIONS: 

  [l_equ,m_states] = size(AA); 
  [l_equ,n_endog ] = size(CC); 
  [l_equ,k_exog  ] = size(DD); 
 
   PERIOD     = 4;    % number of periods per year, i.e. 4 for quarterly 
   HORIZON    = 200;   % 20 quarters 
   GNP_INDEX  = 3;    % Index of output among the variables selected for HP filter 
   DO_SIMUL   = 1;    % Calculates simulations 
   DO_HP_FILTER   = 1; %  
   DO_MOMENTS   = 1; %  Calculates moments based on frequency-domain methods
   HP_SELECT  = 1:(m_states+n_endog+k_exog); % Selecting the variables for the HP Filter 
   SIM_N_SERIES = 200;
   SIM_LENGTH   = 200;
   DO_STATE_RESP= 0;
   
   
    IMP_SELECT   = [1: 2  ]; % Vector with the indices of the variables to be plotted: all X variables
    IMP_SELECT   = [3 : 10  ]; % Vector with the indices of the variables to be plotted: all Y variables
   % Uncomment the line above and run your file again to see the response of the Y variables

    do_it; % Starts calculations 
    
	% 	c) Testing condition on lambda

	lamdat=Resp_mat(9,:);
	lamdallFOC(2:HORIZON)=((1-phi)*Resp_mat(8,1:(HORIZON-1))+(b*(1-phi)-1)*Resp_mat(2,1:(HORIZON-1)))/m_bar+beta*pie_bar/(1+pie_bar)*(Resp_mat(9,2:HORIZON)-pie_bar*Resp_mat(7,2:HORIZON));
	lamda_diff=lamdat-lamdallFOC;
    lamda_rediff=(lamdat-lamdallFOC)./lamdat;	
	plot(1:HORIZON,lamda_diff);
	hold on;
	plot(1:HORIZON,lamda_rediff,'--r');
	hold on;
	title('difference and relative difference (red dashed) for lambda');
	xlabel('periods');
	ylabel('differences');
	

  %      ........... generated by SimulEditor